/********
   Compile with:
	cc -o read-trackd read-trackd.c trackdmem.c
********/

#include <stdio.h>
#include "trackdmem.h"


main(int argc,char **argv)
	{
	int trackerKey, controllerKey, readController=0;
	void *tracker=NULL;
	void *controller=NULL;
	if (argc < 2)
		{
		fprintf(stderr,"Usage: %s tracker-shmem-key "
			"[controller-shmem-key]\n", argv[0]);
		exit(1);
		}
	trackerKey = atoi(argv[1]);
	if (argc > 2)
		{
		readController = 1;
		controllerKey = atoi(argv[2]);
		}

	tracker = trackd_attach_tracker_mem(trackerKey);
	if (readController)
		controller = trackd_attach_controller_mem(controllerKey);

	while (1)
		{
		int i;
		if (tracker)
			{
			printf("%d sensors\n",trackd_num_sensors(tracker));
	 		for (i=0; i < trackd_num_sensors(tracker); i++)
				{
				CAVE_SENSOR_ST *daemonSensor;
				daemonSensor = trackd_sensor(tracker,i);
				printf("sensor %d: (%.3f,%.3f,%.3f) "
					"(%.3f,%.3f,%.3f)  time %d.%06d\n", i,
					daemonSensor->x,
					daemonSensor->y,
					daemonSensor->z,
					daemonSensor->elev,
					daemonSensor->azim,
					daemonSensor->roll,
					daemonSensor->timestamp[0],
					daemonSensor->timestamp[1]);
				}
			}
		if (controller)
			{
			printf("controller:");
			printf(" %d buttons, %d valuators: ",
				trackd_num_buttons(controller),
				trackd_num_valuators(controller));
			for (i=0; i < trackd_num_buttons(controller); i++)
				printf(" %d",trackd_button(controller,i));
			printf("     ");
			for (i=0; i < trackd_num_valuators(controller); i++)
				printf(" %.3f",trackd_valuator(controller,i));
			printf("\n");
			}
		sleep(1);
		}
	}
