#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <limits.h>
#include <sys/prctl.h>
#include <sys/schedctl.h>
#include "trackd.h"

static int tracker_shmid=-1;
static struct TRACKD_TRACKING	*tracker=NULL;



void init_tracker(void)
{
/**** Insert your code here ****/
}

int get_new_tracker_data(CAVE_SENSOR_ST *data,int *sensorNum)
{
/**** Insert your code here ****/
/* if (new tracker data is available)
	{
	*data = the_new_data;
	*sensorNum = ID_number_of_the_sensor;  [0=head, 1=wand]
	return 1;
	}
   else
	return 0;
*/
}



/*************************************************************************
 void trackd_cleanup()
	When the daemon is interrupted by SIGINT, this routine closes the
 connections, disposes of the memory, and exits.
**************************************************************************/
void trackd_cleanup(void)
{
 fprintf(stderr,"Interrupted.  Quitting...\n");
 if (tracker)
	if (shmdt(tracker) < 0)
		perror("Detaching 'tracker' shared memory");
 if (tracker_shmid > -1)
	if (shmctl(tracker_shmid,IPC_RMID) < 0)
		perror("Removing 'tracker_shmid'");
 exit(-1);
}

/*************************************************************************
 void get_tracker_mem()
	Allocates shared memory for the sensors.  The global 'tracker'
  points to the chunk.
**************************************************************************/
void get_tracker_mem(CAVE_CONFIG_ST *config)
{
 tracker_shmid = shmget(config->TrackdKey, sizeof(struct TRACKD_TRACKING),
			0666 | IPC_CREAT);
 if (tracker_shmid < 0)
	{
	fprintf(stderr,"can't get shared memory\n");
	exit(-1);
	}
 tracker = (struct TRACKD_TRACKING *) shmat(tracker_shmid,(char *) 0, 0);
 if (tracker == (struct TRACKD_TRACKING *) -1)
	{
	fprintf(stderr,"can't attach shared memory\n");
	exit(-1);
	}
}


/*************************************************************************
 void init_tracker_data()
	Fills in the header of the tracker data, and fills all the sensors
  with defaults from the config file.
**************************************************************************/
void init_tracker_data(CAVE_CONFIG_ST *config)
{
 int loop;
 CAVE_SENSOR_ST sensor;

 tracker->header.version = CAVELIB_2_6;
 tracker->header.numSensors = 2;
 tracker->header.sensorOffset = ((char *)&tracker->sensor[0]) - ((char *)tracker);
 tracker->header.sensorSize = sizeof(CAVE_SENSOR_ST);
 tracker->header.timestamp[0] = tracker->header.timestamp[1] = 0;
 tracker->header.command = 0;

 sensor.x = config->DefaultTrackerPosition[0];
 sensor.y = config->DefaultTrackerPosition[1];
 sensor.z = config->DefaultTrackerPosition[2];
 sensor.elev = config->DefaultTrackerOrientation[0];
 sensor.azim = config->DefaultTrackerOrientation[1];
 sensor.roll = config->DefaultTrackerOrientation[2];
 sensor.calibrated = 0;

 for (loop=0; loop < TRACKD_MAX_SENSORS; ++loop)
	tracker->sensor[loop] = sensor;
}

		

void get_timestamp(uint32_t stamp[2])
{
 struct timeval curtime;
 gettimeofday(&curtime,NULL);
 stamp[0] = curtime.tv_sec;
 stamp[1] = curtime.tv_usec;
}


void process_tracker_command(int command)
{
/* In the future, code to accept external commands would go here */
}


main(int argc,char **argv)
{
 int loop, sensornum;
 CAVE_CONFIG_ST config;
 CAVE_SENSOR_ST sensor;

 signal(SIGINT,trackd_cleanup); /* catch interrupts to close nicely */
 schedctl(NDPRI,0,NDPHIMIN);  /* set a non-degrading priority */

 if (!getenv("CAVEDEBUGCONFIG"))
        putenv("CAVEDEBUGCONFIG=OFF");
 CAVEConfigurationInit(&argc,argv,NULL,&config);

 get_tracker_mem(&config);

 init_tracker_data(&config);

 init_tracker();

 while (1)
	{
	if (get_new_tracker_data(&sensor,&sensornum))
		{
		tracker->sensor[sensornum] = sensor;
		get_timestamp(tracker->header.timestamp);
		}
	if (tracker->header.command)
		{
		process_tracker_command(tracker->header.command);
		tracker->header.command = 0;
		}
	}
}
